#include "gpdef.h"
#include "gpstdlib.h"
#include "gpfont.h"
#include "gpgraphic.h"
#include "gpstdio.h"

#include "stdio.h"

#include "gpmain.h"
#include "util.h"
#include "draw.h"
#include "sound.h"
#include "title.h"
#include "config.h"


CONFIG * config;

GPDRAWSURFACE gpDraw[2];
int nflip;

int frame;

int	pos_x;
int	pos_y;

LEVEL * level;

int current_level;
int	round;

BLOCK * block1;
BLOCK * block2;

BLOCK * bird1;
BLOCK * bird2;

HENTORI * hentori;
DRAGOLO * dragolo;

int	perso_pos_x;
int	perso_pos_y;
int	perso_state;
int	perso_touche;

int	perso_live;

int action;

int speed;
int level_speed;
int pos_min_level_move;
int pos_min_level_plante;


int frame_jump;

int mvt_jump;

int jump_boss;
int perso_vs_boss;

int	keydata;

int score;
int level_score;
int write_score;
int write_monsters_score;

int best_score;

extern GP_PALETTEENTRY game_Pal[256];

extern const unsigned int sky[][];
extern const unsigned int climber1[][];
extern const unsigned int climber2[][];
extern const unsigned int climber3[][];
extern const unsigned int climber4[][];
extern const unsigned int climber5[][];
extern const unsigned int blockman[][];
extern const unsigned int eyeron1[][];
extern const unsigned int eyeron2[][];
extern const unsigned int hentori1[][];
extern const unsigned int hentori2[][];
extern const unsigned int hentori3[][];
extern const unsigned int hentori4[][];
extern const unsigned int dragolo_top[][];
extern const unsigned int dragolo_bottom[][];

extern const unsigned int knife[][];
extern const unsigned int plante[][];
extern const unsigned int live[][];

int sound_onoff;


void WriteBlock(int x, int y){
	int k;
	for (k=0; k<5; k++ )
		GpRectDraw(&gpDraw[nflip],x+k*10, y, x+k*10+8 ,y+1 ,0x00);
	for (k=0; k<5; k++ )
		GpRectDraw(&gpDraw[nflip],2+x+k*10, y+3, 2+x+k*10+8 ,y+4 ,0x00);	
}

void WriteDemiBlock(int x, int y){
	int k;
	for (k=0; k<5; k++ )
		GpRectDraw(&gpDraw[nflip],x+k*10, y, x+k*10+8 ,y+1 ,0x00);	
}

void WriteGround(){	
	GpBitBlt(NULL, &gpDraw[nflip], 0, 0, 320, 240, (unsigned char*)sky, 0, 0, 320,240);		         
}

void WritePlante(int x, int y){	
	GpTransBlt(NULL, &gpDraw[nflip],
	           x, y-PLANTE_H,
	           PLANTE_W, PLANTE_H,
	           (unsigned char*)plante, 
	           0, 0, 
	           PLANTE_W, PLANTE_H,
	           0xff);
	GpTransUDBlt(NULL, &gpDraw[nflip],
	           x-PLANTE_W, y-PLANTE_H-BLOCK_SPACE_H/2-10,
	           PLANTE_W, PLANTE_H,
	           (unsigned char*)plante, 
	           0, 0, 
	           PLANTE_W, PLANTE_H,
	           0xff);			           	
}

void WriteTexte(char * string, int x, int y){
	WriteTxt( &gpDraw[nflip], string, x, y );
}

void WriteLives(){
	if ( perso_live<3 )
		WriteTexte( "miss", 17, 0 );
			
	if ( perso_live<3 )
		GpTransBlt(NULL, &gpDraw[nflip],
			           10, 17,
			           12, 12,
			           (unsigned char*)live, 
			           0, 0, 
			           12, 12,
			           0xff);		
	if ( perso_live<2 )	
		GpTransBlt(NULL, &gpDraw[nflip],
			           28, 17,
			           12, 12,
			           (unsigned char*)live, 
			           0, 0, 
			           12, 12,
			           0xff);
	if ( perso_live<1 )	
		GpTransBlt(NULL, &gpDraw[nflip],
			           46, 17,
			           12, 12,
			           (unsigned char*)live, 
			           0, 0, 
			           12, 12,
			           0xff);
}


void writeBackGround(){
	int	 i, j;
	int	 x, y;
	char string[256];	
	WriteGround();
	for (i=0; i<MIN(3, current_level+1); i++ ){
		HLEVEL hlevel =  (*level).lines[current_level - i];
		for (j=0; j<MAX_BLOCK_Y; j++ ){ 
			x = BLOCK_SPACE_W + (BLOCK_W)*j;
			y = 200 - i*BLOCK_SPACE_H;
			if ( hlevel.blocks[j] > 1 )
				WriteBlock( x, y);
			else if ( hlevel.blocks[j] > 0 )
				WriteDemiBlock( x, y);
		}
		for (j=0; j<MAX_BLOCK_Y; j++ ){
			x = BLOCK_SPACE_W + BLOCKMAN_W/2+ (BLOCK_W)*j;
			y = 200 - i*BLOCK_SPACE_H;
			if ( hlevel.plantes[j] == 1 && i<2 ) 
				WritePlante(x, y);			
		}							
	}
	if ( perso_vs_boss !=0 )
		for (j=0; j<MAX_BLOCK_Y; j++ ){ 
			if ( ( j>1 && j<(MAX_BLOCK_Y-2)) )
				continue;
			x = BLOCK_SPACE_W + (BLOCK_W)*j;
			y = 200 - 2*BLOCK_SPACE_H;				
			WriteBlock( x, y);					
		}	
		
	
	if ( write_score == -1 )
		sprintf((char*)string, round>9 ? "P %d": "P  %d" , round);
	else if ( write_score == 0  )
		sprintf((char*)string, current_level>8 ? "  %d": "  0%d" , current_level<MAX_LINE_X ? current_level+1 : MAX_LINE_X);
	else
		sprintf((char*)string, (score<10 ? "   %d": score<100 ? "  %d" : score<1000 ? " %d" : "%d" ) , score );
	
	WriteTexte( (char*)string, 280, 5 );
	
	WriteLives();					                 		
}

void upMonster(BLOCK * block){
	if ( (*block).level==current_level ){
		(*block).state=HIDDEN;
		(*block).level-=2;
		(*block).pos_y=1;
	 }
	 else if ( (*block).level==(current_level-1) ){
	 	(*block).pos_y=0;
	 }
}	

void upMonsters(){
	upMonster(block1);
	upMonster(block2);
	upMonster(bird1);
	upMonster(bird2);
}	

int checkColisionPlantes(int pers_x_old, int pers_x_new, int pers_y_old, int pers_y_new ){
	HLEVEL hlevel =  (*level).lines[current_level];
	HLEVEL shlevel;
	int bad;
	if ( current_level>0 )
		shlevel = (*level).lines[current_level-1];
	if ( pers_x_old!=pers_x_new ){
		if ( (pers_x_new-pers_x_old)==1  )
			 bad = pers_x_new;
		else if ( (pers_x_new-pers_x_old)==-1 )	 
			bad = pers_x_old;
		else
			 bad = -1;		
		if ( pers_y_new>1 && current_level>0 && bad!=-1 && shlevel.plantes[bad]==1 )
			return 0;
		else if (  pers_y_new<2 && bad!=-1 && hlevel.plantes[bad]==1 )
			return 0;			
	}	
	return	1;
}	
	
	

void checkClimber(){
	HLEVEL hlevel =  (*level).lines[current_level];
	HLEVEL shlevel;
	if ( current_level>0 )
		shlevel = (*level).lines[current_level-1];
	if( perso_pos_y == 0 ){
		if ( hlevel.blocks[perso_pos_x] == 0 ){	
			perso_state=ERROR;
			perso_touche = FALL;
			return;
		}	
	}
	if ( action == JUMP ){
		if ( current_level>0 && shlevel.blocks[perso_pos_x]>0 && perso_pos_y==1){
			action = FALL;
			if ( current_level>1 && shlevel.type== HLEVEL_FIX )
				shlevel.blocks[perso_pos_x]--;
			(*level).lines[current_level-1]=shlevel;
		}
		else if ( current_level==0 &&  perso_pos_y==1 /*&& shlevel.type== HLEVEL_FIX*/  )	{
			hlevel.blocks[perso_pos_x]--;
			(*level).lines[current_level]=hlevel;
		}				
	}else if ( action == FALL ){		 
		if ( current_level>0 && shlevel.blocks[perso_pos_x]>0 && perso_pos_y==2){
			action = 0;
			upMonsters();
			current_level--;
			level_score++;
			perso_pos_y = 0;
			PlayJumpSound( 6,sound_onoff );	
		}
	}	
}





void writeClimber(){
	int x, y;
	x = BLOCK_SPACE_W + BLOCKMAN_W/2 + PLANTE_W+ (perso_pos_x) * (BLOCK_W);
	y = 200 - CLIMBER_H ;
	if( perso_pos_y == 0 ){
		if ( perso_state== SLEEP && frame%4==0 ){}
		else if ( perso_pos_x%2 == 0 )
			GpTransBlt(NULL, &gpDraw[nflip],
			           x, y,
			           CLIMBER_W, CLIMBER_H,
			           (unsigned char*)climber1, 
			           0, 0,
			           CLIMBER_W, CLIMBER_H,
			           0xff);		
		else	GpTransLRBlt(NULL, &gpDraw[nflip],
			           x+4, y,
			           CLIMBER_W, CLIMBER_H,
			           (unsigned char*)climber1, 
			           0, 0, 
			           CLIMBER_W, CLIMBER_H,
			           0xff);		

	}else if( perso_pos_y == 1 ){
		GpTransBlt(NULL, &gpDraw[nflip],
		           x, y-BLOCK_SPACE_H+CLIMBER_H+2,
		           CLIMBER_W, CLIMBER_H,
		           (unsigned char*)climber2, 
		           0, 0, 
		           CLIMBER_W, CLIMBER_H,
		           0xff);		
	}else if( perso_pos_y == 2 ){
		GpTransBlt(NULL, &gpDraw[nflip],
		           x,  y-BLOCK_SPACE_H,
		           CLIMBER_W, CLIMBER_H,
		           (unsigned char*)climber1, 
		           0, 0, 
		           CLIMBER_W, CLIMBER_H,
		           0xff);
	}else if( perso_pos_y == 3 ){
		GpTransBlt(NULL, &gpDraw[nflip],
		           x, y-2*BLOCK_SPACE_H+CLIMBER_H+6,
		           CLIMBER_W, CLIMBER_H,
		           (unsigned char*)climber3, 
		           0, 0, 
		           CLIMBER_W, CLIMBER_H,
		           0xff);	
	}else if( perso_pos_y == 4 ){
		GpTransBlt(NULL, &gpDraw[nflip],
		           x, CLIMBER_H+10,
		           CLIMBER_W, CLIMBER_H,
		           (unsigned char*)climber4, 
		           0, 0, 
		           CLIMBER_W, CLIMBER_H,
		           0xff);	
	}else if( perso_pos_y == 5 ){
		GpTransBlt(NULL, &gpDraw[nflip],
		           185, 17,
		           CLIMBER_W, CLIMBER_H,
		           (unsigned char*)climber4, 
		           0, 0, 
		           CLIMBER_W, CLIMBER_H,
		           0xff);	
	}else if( perso_pos_y == -1 ){
		GpTransBlt(NULL, &gpDraw[nflip],
		           x, 203+2*BLOCK_H,
		           CLIMBER_W+5, CLIMBER_H,
		           (unsigned char*)climber5, 
		           0, 0,
		           CLIMBER_W+5, CLIMBER_H,
		           0xff);		
	}	
}

void writeKnife(DRAGOLO * dragolo){
		if ( perso_state == WIN ){
			if ( (*dragolo).pos_y == 0 )
				GpTransBlt(NULL, &gpDraw[nflip],
				           100, DRAGOLO_H + 10,
				           KNIFE_W, KNIFE_H,
				           (unsigned char*)knife, 
				           0, 0, 
				           KNIFE_W, KNIFE_H,
				           0xff);  
			else 	           
				GpTransBlt(NULL, &gpDraw[nflip],
				           100, 15,
				           KNIFE_W, KNIFE_H,
				           (unsigned char*)knife, 
				           0, 0, 
				           KNIFE_W, KNIFE_H,
				           0xff); 			
			
			
		}else 
			GpTransBlt(NULL, &gpDraw[nflip],
				           120, DRAGOLO_H + 10,
				           KNIFE_W, KNIFE_H,
				           (unsigned char*)knife, 
				           0, 0, 
				           KNIFE_W, KNIFE_H,
				           0xff); 			
			
}

void writeDragolo(DRAGOLO * dragolo){	
	if ( (* dragolo).state==MOVE ){
		if ( (*dragolo).pos_y == 0 ){
			GpTransBlt(NULL, &gpDraw[nflip],
				           50, DRAGOLO_H,
				           DRAGOLO_W, DRAGOLO_H,
				           (unsigned char*)dragolo_bottom, 
				           0, 0, 
				           DRAGOLO_W, DRAGOLO_H,
				           0xff);			
			
			
		}else if ( (*dragolo).pos_y == 1 ){
			GpTransBlt(NULL, &gpDraw[nflip],
				           50, 5,
				           DRAGOLO_W, DRAGOLO_H,
				           (unsigned char*)dragolo_top, 
				           0, 0, 
				           DRAGOLO_W, DRAGOLO_H,
				           0xff);
		}	
	}	
}

void writeHentori(HENTORI * hentori){
	if ( (*hentori).state==MOVE ){
		if ( (*hentori).pos_y == 0 ){
			GpTransBlt(NULL, &gpDraw[nflip],
				           100, 0,
				           HENTORI_W, HENTORI_H,
				           (unsigned char*)hentori1, 
				           0, 0, 
				           HENTORI_W, HENTORI_H,
				           0xff);					
			
			
		}else if ( (*hentori).pos_y == 1 ){
			if ( (*hentori).frame%20 >= 0 && (*hentori).frame%20 < 10 )	
				GpTransBlt(NULL, &gpDraw[nflip],
					           130, 15,
					           HENTORI_W, HENTORI_H,
					           (unsigned char*)hentori2, 
					           0, 0, 
					           HENTORI_W, HENTORI_H,
					           0xff);
			else	
				GpTransBlt(NULL, &gpDraw[nflip],
				           130, 15,
				           HENTORI_W, HENTORI_H,
				           (unsigned char*)hentori3, 
				           0, 0, 
				           HENTORI_W, HENTORI_H,
				           0xff);				           
		}else if ( (*hentori).pos_y == 2 ){		           
			GpTransBlt(NULL, &gpDraw[nflip],
				           190, 0,
				           HENTORI_W, HENTORI_H,
				           (unsigned char*)hentori4, 
				           0, 0, 
				           HENTORI_W, HENTORI_H,
				           0xff);				
		}	
	}	
}	

void writeBlockman(BLOCK * block){
	int x, y;
	if ( (*block).state==MOVE ){
		x = BLOCK_SPACE_W - BLOCKMAN_W/2 + (*block).pos_x *(BLOCK_W);
		y = 200 - BLOCKMAN_H - (*block).pos_y * BLOCK_SPACE_H;
		if ( (*block).pos_x%2 == 0 )
			GpTransBlt(NULL, &gpDraw[nflip],
			           x, y,
			           BLOCKMAN_W, BLOCKMAN_H,
			           (unsigned char*)blockman, 
			           0, 0, 
			           BLOCKMAN_W, BLOCKMAN_H,
			           0xff);		
		else 	GpTransLRBlt(NULL, &gpDraw[nflip],
			           x, y,
			           BLOCKMAN_W, BLOCKMAN_H,
			           (unsigned char*)blockman, 
			           0, 0, 
			           BLOCKMAN_W, BLOCKMAN_H,
			           0xff);           
	}	
}

void writeEyeron(BLOCK * block){
	int x, y;
	if ( (*block).state==MOVE ){
		x = BLOCK_SPACE_W - EYERON_W/2 + (*block).pos_x *(BLOCK_W);
		y = 200 - BLOCK_SPACE_H + 5 - (*block).pos_y * BLOCK_SPACE_H;
		if ( (*block).pos_x%2 == 0 )
			GpTransBlt(NULL, &gpDraw[nflip],
			           x, y,
			           EYERON_W, EYERON_H,
			           (unsigned char*)eyeron1, 
			           0, 0, 
			           EYERON_W, EYERON_H,
			           0xff);		
		else 	GpTransBlt(NULL, &gpDraw[nflip],
			           x, y,
			           EYERON_W, EYERON_H,
			           (unsigned char*)eyeron2, 
			           0, 0, 
			           EYERON_W, EYERON_H,
			           0xff);           
	}	
}


void writeMonsters(){
	writeBlockman(block1);	
	writeBlockman(block2);
	writeEyeron(bird1);
	writeEyeron(bird2);		
}


int checkColisionBlock(BLOCK * block , int pers_x_old, int pers_x_new, int pers_y_old, int pers_y_new ){
	int oldx= 0;
	int newx= 0;
	if ( block==NULL)
		return 1;
	if ( (*block).state==MOVE && perso_state!= SLEEP
	     && ( ( (*block).type==BLOCKMAN && 
	            ( ( (*block).pos_y == 0 && perso_pos_y==0 )  || ( (*block).pos_y == 1 && perso_pos_y==2 ) )
	          )
	          || 
	          ( (*block).type==EYERON &&
	            ( ( (*block).pos_y == 0 && perso_pos_y==1 )  || ( (*block).pos_y == 1 && perso_pos_y==3 ) )
	          )  
	   	)         
	   ){
		oldx= (*block).pos_x;
		newx= (*block).pos_x+(*block).sens;
		if ( pers_x_old == pers_x_new && pers_y_old == pers_y_new ) {
			if ( ( newx>oldx && perso_pos_x==oldx ) || ( newx<oldx && perso_pos_x==newx ) )
				return 0;
			else 
				return 1;	
		}else {
			oldx= pers_x_old;
			newx= pers_x_new;
			if ( ( (newx-oldx)==1 && (*block).pos_x==newx)
			     || ( (oldx-newx)==1 && (*block).pos_x==oldx) 
			     || ( (newx-oldx)>1 && (*block).pos_x==0 )
			     || ( (oldx-newx)>1 && (*block).pos_x==MAX_BLOCK_Y )   )
				return 0;
			else 
				return 1;	
		}		
	}
	else 
		return 1;		
}

void moveHentori(HENTORI * hentori){
	int state = (*hentori).state;
	(*hentori).frame_move++;
	(*hentori).frame++;
	if ( state==MOVE ){
		if ( (*hentori).pos_y!=1 && (*hentori).frame_move>20 ){
			(*hentori).pos_y++;
			(*hentori).frame_move = 0;
			(*hentori).frame = 0;
			(*hentori).speed = Random(3) * 20;
			
		}	
		else if ( (*hentori).pos_y==1 && (*hentori).frame>(*hentori).speed ){	
			if ( (*hentori).frame>20  ) {
				if ( Random(3)==1 ){
					(*hentori).pos_y++;
					(*hentori).frame_move = 0;
				}
				(*hentori).frame = 0;
			}	
		}	
		if ( (*hentori).pos_y>2 ){
			(*hentori).state=HIDDEN;
			(*hentori).frame = 0;
			(*hentori).frame_move = 0;
			(*hentori).speed = Random(5) * 20;
		}	
	 }
	 else {
	 	if ( (*hentori).frame>(*hentori).speed ){
	 		if ( Random(3)==1 ) {
				(*hentori).state=MOVE ;
				(*hentori).pos_y=0;
				(*hentori).frame_move = 0;
				(*hentori).frame = 0;
			}
			
		}	 	
	 }
	 // checkPerso	
	 if ( perso_pos_y == 4 && (*hentori).pos_y==1 )
	 	perso_state = WIN;	
	 
	 (*hentori).frame_move %=1000;		
}


void moveDragolo(DRAGOLO * dragolo){
	(*dragolo).frame++;
	(*dragolo).frame_move++;
	if ( (*dragolo).frame_move%speed == 0 ) {
		if ( (*dragolo).pos_y==0  ){
			if ( (*dragolo).frame>8 || Random(4)>1 ){
				(*dragolo).pos_y++;
				(*dragolo).frame=0;
				StopPlaySound(sound_onoff); 
				PlayDragoloSound((*dragolo).pos_y, sound_onoff );
			}	
		}	
		else if ( (*dragolo).pos_y==1 ){	
			if ( (*dragolo).frame>5 || Random(2)>1 ) {
				(*dragolo).pos_y--;
				(*dragolo).frame=0;
				StopPlaySound(sound_onoff); 
				PlayDragoloSound((*dragolo).pos_y , sound_onoff); 
			}	
		}	
	}		
	// checkPerso
	 if ( perso_pos_y == 4 ){
	 	if ( ( (*dragolo).pos_y==0 && !(keydata & KEY_UP) )
	 		||
	 	     ( (*dragolo).pos_y==1 && keydata & KEY_UP  ) )
	 		perso_state = WIN;	
	 	//perso_pos_y = 5;
	 }
	 (*dragolo).frame_move %=1000;		 	
}
	

void moveMonster(BLOCK * block){
	HLEVEL hlevel =  (*level).lines[(*block).level];	
	if ( ( (*block).level<1 || hlevel.type == HLEVEL_MOVE )&& (*block).type==BLOCKMAN )
		return;
	(*block).frame_move++;	
	if ( (*block).state==MOVE && 
		( ( (*block).type==BLOCKMAN && (*block).frame_move%speed == 0 ) ||
		  ( (*block).type==EYERON && (*block).frame_move%speed == 0 ) ) ){
		if ( checkColisionBlock( block , 0 , 0, 0 , 0)==1 ) {
			if ( (*block).type==BLOCKMAN && (*block).sens > 0 && hlevel.blocks[(*block).pos_x]<2 ){
				hlevel.blocks[(*block).pos_x]=2;
				(*block).state=HIDDEN;
				(*block).pos_x=-1;
			 }
			 else if ( (*block).type==BLOCKMAN && (*block).sens < 0 && hlevel.blocks[(*block).pos_x-1]<2 ){
				hlevel.blocks[(*block).pos_x-1]=2;
				(*block).state=HIDDEN;
				(*block).pos_x=-1;
			 }	
			if ( (*block).state==MOVE  ){
				(*block).pos_x+= (*block).sens;
				if ( (*block).pos_x>(MAX_BLOCK_Y+1))
					(*block).state=HIDDEN;
				else if ( (*block).pos_x<0)
					(*block).state=HIDDEN;	
			}
			if ( (*block).type==BLOCKMAN )
				PlayBlockmanSound(sound_onoff);
			else 	
				PlayEyeronSound(sound_onoff);
		 }		
		else 
			perso_state=ERROR;
		
	}else if ( (*block).state==HIDDEN ) {
		(*block).frame++;
		if ( (*block).frame>(*block).speed ) {
			//TODO : if (Random(5)==1 ) {
			if (Random(3)==1 ) {
				(*block).state=MOVE ;
				if ( (*block).type==EYERON ) 
					(*block).sens= 1;
				else if ((*block).pos_y==0 )
					(*block).sens= ( perso_pos_x < 2 ? -1 : 1 );	
				else
					(*block).sens= ( Random(2) > 1 ? -1 : 1 );	
				if ((*block).sens==1)
					(*block).pos_x=0;
				else 	
					(*block).pos_x=MAX_BLOCK_Y+1;
				(*block).frame=0;
				(*block).frame_move = 0;
				if ( (*block).type==BLOCKMAN )
					PlayBlockmanSound(sound_onoff);
				else 	
					PlayEyeronSound(sound_onoff);				
			}
			else 
				(*block).frame=0;
		}		
	}
	(*level).lines[(*block).level]=  hlevel;
	(*block).frame_move %=1000;				
}


void moveLine(int pos ){
	int i;
	int oldposx=perso_pos_x;
	HLEVEL hlevel = (*level).lines[pos];
	if ( hlevel.type== HLEVEL_FIX )
		return;	
	hlevel.frame%=1000;
	hlevel.frame++;
	if ( hlevel.frame%hlevel.speed==0 ) 
		for ( i = 0 ; i < MAX_BLOCK_Y; i++ ) 
			if ( hlevel.blocks[i]==2 ) {
				hlevel.blocks[i]=0;
				if ( perso_pos_x == i && current_level==pos && perso_pos_y==0 ){
					perso_pos_x+=hlevel.sens;
					if ( hlevel.sens==1 && perso_pos_x==MAX_BLOCK_Y )
						perso_pos_x = 0;
					else if ( hlevel.sens==-1 && perso_pos_x<0 ) 
						perso_pos_x = (MAX_BLOCK_Y-1);
					if ( checkColisionPlantes(oldposx, perso_pos_x, perso_pos_y, perso_pos_y )==0 )	
						perso_pos_x = oldposx;
				}	
				i+=hlevel.sens;
				if ( hlevel.sens==1 && i==MAX_BLOCK_Y ) 
					i = 0;
				else if ( hlevel.sens==-1 && i<0 ) 
					i = (MAX_BLOCK_Y-1);	
				hlevel.blocks[i]=2;
				(*level).lines[pos]=hlevel;
				return;
			}
	(*level).lines[pos]=hlevel;					
}	

void moveLevel(){
	moveLine( current_level);	
	if ( current_level>0 ){
		moveLine(  current_level-1);	
	}
	if ( current_level>1 ){
		moveLine(  current_level-2);	
	}		
		
}		

void moveMonsters(){
	moveMonster( block1 );
	moveMonster( block2 );
	moveMonster( bird1 );
	moveMonster( bird2 );
}


void moveClimber(){
	int oldposx = perso_pos_x;
	int oldposy = perso_pos_y;
	
	if ( KeyChanged() ){
		if( keydata & KEY_RESET  ) ResetHardware();
		if( keydata & KEY_SELECT   ) ReturnTitle();	
		if(keydata & KEY_START  ) ResetGame();
		
		if(keydata & KEY_LEFT  && mvt_jump == 0 && action  != FALL )	{ perso_pos_x--; mvt_jump++; action  = FALL;perso_state= OK;}
		if(keydata & KEY_RIGHT  && mvt_jump == 0 && action  != FALL )	{perso_pos_x++; mvt_jump++; action  = FALL;perso_state= OK;}
		if(keydata & KEY_DOWN && action  == JUMP)	action  = FALL;
		if( (keydata & KEY_JUMP) && action  != FALL) { action  = JUMP; perso_state= OK;}	
	}

	if ( perso_pos_x == MAX_BLOCK_Y )
		perso_pos_x = 0;
	else if ( perso_pos_x < 0 )	
		perso_pos_x = MAX_BLOCK_Y-1;

	if ( checkColisionPlantes(oldposx, perso_pos_x, oldposy, perso_pos_y )==0 )
		perso_pos_x=oldposx;		
	
	if ( oldposx!=perso_pos_x  && 
	     ( checkColisionBlock( block1 ,  oldposx, perso_pos_x, oldposy, perso_pos_y )==0 ||
	       checkColisionBlock( block2 ,  oldposx, perso_pos_x, oldposy, perso_pos_y )==0 ||
	       checkColisionBlock( bird1 ,  oldposx, perso_pos_x, oldposy, perso_pos_y )==0 ||
	       checkColisionBlock( bird2 ,  oldposx, perso_pos_x, oldposy, perso_pos_y )==0 ) ){
		perso_state=ERROR;
		perso_pos_x=oldposx;		
		return;
	}
	
	if (  action  == JUMP ){
		frame_jump ++;
		if( ( perso_pos_y == 3 && perso_vs_boss == 0 ) || ( perso_pos_y == 4 && perso_vs_boss > 0 ))
			action  = FALL;
		else if ( frame_jump > 2 || perso_pos_y	< 2){		
			perso_pos_y ++; 
			frame_jump =0;	
		}	
	}
	if (  action  == FALL ){
		frame_jump ++;
		if( perso_pos_y	== 0){
		 	action  = 0;	
		}				
		else if ( frame_jump > 3){
			perso_pos_y --;
			frame_jump =0;	
		}	
	}

	if ( oldposx!=perso_pos_x  && ( checkColisionBlock( block1 ,  oldposx, perso_pos_x, oldposy, perso_pos_y  )==0 ||
		checkColisionBlock( block2 ,  oldposx, perso_pos_x, oldposy, perso_pos_y  )==0) ){
		perso_state=ERROR;
		perso_pos_x=oldposx;		
		return;
	}
	if ( oldposx!=perso_pos_x  &&  ( checkColisionBlock( bird1 ,  oldposx, perso_pos_x, oldposy, perso_pos_y  )==0 ||
		checkColisionBlock( bird2 ,  oldposx, perso_pos_x, oldposy, perso_pos_y  )==0) ){
		perso_state=ERROR;
		perso_pos_x=oldposx;		
		return;
	}	

	
	if ( oldposy!=perso_pos_y ) {
		if ( action  == JUMP && perso_pos_y==1 )
			PlayJumpSound( 1, sound_onoff );	
		else if ( action  == JUMP && perso_pos_y==2 )
			PlayJumpSound( 2, sound_onoff );	
		else if ( action  == JUMP && perso_pos_y==3 )
			PlayJumpSound( 3, sound_onoff );	
		else if ( action  == FALL && perso_pos_y==2 )
			PlayJumpSound( 4, sound_onoff );	
		else if ( action  == FALL && perso_pos_y==1 )
			PlayJumpSound( 5, sound_onoff );	
		else if ( perso_pos_y==0 )
			PlayJumpSound( 1, sound_onoff );	
			
	}	 
	if ( oldposx!=perso_pos_x  )
		PlayMoveSound(sound_onoff);
			
	if ( action == 0 ){
		frame_jump =0;	
		mvt_jump = 0;
	}	
}		

void buildField(){
	int	 i, j, nbplantes;
	gp_mem_func.free((void*) level );
	level = NULL;
	level = (LEVEL *) gp_mem_func.malloc( sizeof(LEVEL) );
	for ( i = 0 ; i < MAX_LINE_X; i++ ) {
		(*level).lines[i].frame=0;
		(*level).lines[i].speed=level_speed;
		if ( i < pos_min_level_move && Random(6)==5 ){
			(*level).lines[i].type = HLEVEL_MOVE;
			if ( i>0 && (*level).lines[i-1].type == HLEVEL_MOVE )
				(*level).lines[i].sens = -(*level).lines[i-1].sens;
			else	
				(*level).lines[i].sens = 1;
		}	
		else
			(*level).lines[i].type = HLEVEL_FIX;
		if ( (*level).lines[i].type == HLEVEL_MOVE ) {
			for ( j = 0 ; j < MAX_BLOCK_Y; j++ ) 
				(*level).lines[i].blocks[j] = 0;
			(*level).lines[i].blocks[Random(MAX_BLOCK_Y-1)]=2;
		}	
		else
			for ( j = 0 ; j < MAX_BLOCK_Y; j++ ) {
				if ( i==0)
					(*level).lines[i].blocks[j] = (j==(MAX_BLOCK_Y-1)/2 ? 2 : 0);
				else
					(*level).lines[i].blocks[j] = (i==(MAX_LINE_X-1) ? 2 : Random(2)*2);							
			}
		
		if ( i < pos_min_level_plante && i>0 ){	
			nbplantes = 0;
			for ( j = 0 ; nbplantes	<3 && j < MAX_BLOCK_Y; j++ ) {
				if (  Random(10)==5 ) {
					(*level).lines[i].plantes[j] = 1;
					nbplantes++;
				}else
					(*level).lines[i].plantes[j] = 0;	 
			}			
		}		
	}		
}

void rebuildField(){
	int	 i, j;
	for ( i = 0 ; i < MAX_LINE_X; i++ ) {
		for ( j = 0 ; j < MAX_BLOCK_Y; j++ ) {
			if ( (*level).lines[i].blocks[j] == 1 )
				(*level).lines[i].blocks[j] = 2;
		}			
	}		
}

void clearMonsters(){
	gp_mem_func.free((void*) block1 );
	block1 = NULL;
	gp_mem_func.free((void*) block2 );
	block2 = NULL;
	gp_mem_func.free((void*) bird1 );
	bird1 = NULL;
	gp_mem_func.free((void*) bird2 );
	bird2 = NULL;

}	

void buildMonsters(){
	clearMonsters();
	block1 = (BLOCK *) gp_mem_func.malloc( sizeof(BLOCK) );
	block2 = (BLOCK *) gp_mem_func.malloc( sizeof(BLOCK) );
	bird1 = (BLOCK *) gp_mem_func.malloc( sizeof(BLOCK) );
	bird2 = (BLOCK *) gp_mem_func.malloc( sizeof(BLOCK) );

	(*block1).sens=1;
	(*block1).pos_x=0;
	(*block1).pos_y=0;	
	(*block1).level=current_level;
	(*block1).state=HIDDEN;
	(*block1).frame=0;
	(*block1).speed=10;
	(*block1).frame_move=0;
	(*block1).type=BLOCKMAN;
	
	(*block2).sens=1;
	(*block2).pos_x=0;
	(*block2).pos_y=1;
	(*block2).level=current_level-1;	
	(*block2).state=HIDDEN;
	(*block2).frame=0;
	(*block2).speed=10;
	(*block2).frame_move=0;
	(*block2).type=BLOCKMAN;	

	(*bird1).sens=1;
	(*bird1).pos_x=0;
	(*bird1).pos_y=0;
	(*bird1).level=current_level;	
	(*bird1).state=HIDDEN;
	(*bird1).frame=0;
	(*bird1).speed=10;
	(*bird1).frame_move=0;
	(*bird1).type=EYERON;
	
	(*bird2).sens=1;
	(*bird2).pos_x=0;
	(*bird2).pos_y=1;
	(*bird2).level=current_level-1;	
	(*bird2).state=HIDDEN;
	(*bird2).frame=0;
	(*bird2).speed=10;
	(*bird2).frame_move=0;
	(*bird2).type=EYERON;
	
}

void FlipBuffer(int sleep){
	FlipSurface(sleep, gpDraw, &nflip, &frame);	
}

void writeIntro(){
	write_score = -1;
	writeBackGround();
	writeClimber();
	FlipBuffer(50);
	PlayIntroTune(sound_onoff);
	Sleep(1700);
	write_score = 0;		
}	

void playLevel(){
	perso_pos_y = 0;
	buildMonsters();
	perso_state= SLEEP;
	action  = 0;
	speed = 35;
	speed -= 6 * (round-1)/5 ;	
	if ( speed <= 0 ) speed = 3;
	frame_jump = 0;
	mvt_jump = 0;
	level_score = 0;
	perso_vs_boss = 0;
	write_monsters_score = 0;
	perso_touche =0;
	
	writeIntro();
	while (	(perso_state==OK || perso_state== SLEEP) && current_level>0 ){
		KeyGet(&keydata);			
	
		moveLevel();
		writeBackGround();
		moveClimber();
		moveMonsters();
		writeClimber();
		writeMonsters();
		checkClimber();
		FlipBuffer(50);		
	 }
}

void writeScore(){
	int ind;
	write_score = 1;
	for (ind=0; ind < level_score; ind++){
		PlayScoreSound(sound_onoff);
		score++;
		writeBackGround();
		writeClimber();
		if ( perso_vs_boss > 0 )
			writeHentori(hentori);
		if ( write_monsters_score == 1 )
			writeMonsters();		
		FlipBuffer(70);	
		if ( score>0 && score%300==0 ){
			PlayHentoriSuccessSound(sound_onoff);
			Sleep(860);
			perso_live =3;
		}	
	}
	if ( perso_vs_boss > 0 ){
		writeBackGround();
		writeClimber();
		writeHentori(hentori);	
		FlipBuffer(50);	
		Sleep(1000);
		
		perso_pos_y = 5;
		(*hentori).pos_y=2;
		writeBackGround();
		writeClimber();
		writeHentori(hentori);	
		FlipBuffer(50);	
		Sleep(1000);
		
		writeBackGround();
		FlipBuffer(50);	
		Sleep(1000);
	}else if ( perso_vs_boss == 0 ){
		writeBackGround();
		writeClimber();
		FlipBuffer(50);	
		Sleep(1500);
	}	
	write_score = 0;
	level_score = 0;		
}

	


void writeChute(){
	int i,j,k;
	int sav_level = current_level;
	//Sleep(1000);
	PlayToucheSound(sound_onoff);	
	if ( perso_touche == FALL ){
		writeBackGround();
		writeMonsters();		
		FlipBuffer(1230);	
		perso_touche =0; 		
		
	}else {	 
		Sleep(280);
		// perso clignote
		writeBackGround();
		writeClimber();
		writeMonsters();		
		FlipBuffer(50);		
		writeBackGround();
		writeMonsters();		
		FlipBuffer(330);		
		writeBackGround();
		writeClimber();
		writeMonsters();		
		FlipBuffer(330);	
		writeBackGround();
		writeMonsters();		
		FlipBuffer(330);		
	}
	rebuildField();
	//Sleep(1000);
	// perso chute
	if ( current_level >= (MAX_LINE_X-2) )
		 sav_level -=2;	
	for (i=sav_level ; i< MIN(sav_level +7, MAX_LINE_X-1); i++){
		current_level ++;
		if ( current_level == MAX_LINE_X )
			current_level --;
		if ( i== ( MIN(sav_level +7, MAX_LINE_X-1)-1 ) ){
			(*level).lines[current_level].type=HLEVEL_FIX;
			for ( k = 0 ; k< MAX_BLOCK_Y; k++ ) {
				(*level).lines[current_level].blocks[k]=2;
			}	
		}
		PlayChute1Sound(sound_onoff);	
		for (j=3; j>-1; j--){
			perso_pos_y = j;
			writeBackGround();
			writeClimber();
			FlipBuffer(230);	
		}	
	}
	PlayChute2Sound(sound_onoff);
	// perso gamele
	perso_pos_y = -1;
	writeBackGround();
	writeClimber();
	FlipBuffer(400);	
	writeBackGround();
	FlipBuffer(400);	
	writeBackGround();
	writeClimber();
	FlipBuffer(520);	
	//Sleep(1320); 
	
		
}				


int playHentori(){
	(*hentori).speed=10;
	jump_boss = 0;
	perso_vs_boss = 1;
	perso_state=OK;
	PlayHentoriTune(sound_onoff); 
	while ( perso_state==OK ){
		KeyGet(&keydata);			
		
		moveLevel();
		writeBackGround();
		moveClimber();
		moveMonsters();
		moveHentori(hentori);
		writeClimber();
		writeMonsters();
		writeHentori(hentori);
		checkClimber();
		FlipBuffer(50);			
	}
	StopPlaySound(sound_onoff); 
	
	if ( perso_state == WIN ){
		writeBackGround();		
		writeClimber();
		writeMonsters();
		writeHentori(hentori);
		FlipBuffer(50);		
		PlayHentoriSuccessSound(sound_onoff); 
		Sleep(860);
		return 20;	
	}	
	else {
		writeBackGround();
		writeMonsters();
		writeHentori(hentori);
		FlipBuffer(50);		
		PlayBossLoseSound(sound_onoff);
		Sleep(1000);
		return 0;	
	}	
}

int playDragalo(){
	int res = 0;
	dragolo = (DRAGOLO *) gp_mem_func.malloc( sizeof(DRAGOLO) ); 
	(*dragolo).pos_y=0;
	(*dragolo).state=MOVE;
	(*dragolo).frame=0;
	(*dragolo).frame_move=0;
	(*dragolo).speed=10;	
	jump_boss = 0;
	perso_vs_boss = 2;
	while ( perso_state==OK ){
		KeyGet(&keydata);			

		moveLevel();
		writeBackGround();
		moveClimber();
		moveMonsters();
		moveDragolo(dragolo);
		writeClimber();
		writeMonsters();
		writeDragolo(dragolo);
		writeKnife(dragolo);
		checkClimber();
		FlipBuffer(50);			
	}
	StopPlaySound(sound_onoff); 
	if ( perso_state == WIN ){
		PlayDragoloSuccessSound(sound_onoff); 
		writeBackGround();
		writeClimber();
		writeMonsters();
		writeDragolo(dragolo);
		writeKnife(dragolo);
		FlipBuffer(50);			
		Sleep(2000);
		res = 30;
	}
	else {	
		PlayBossLoseSound(sound_onoff);
		writeBackGround();
		writeMonsters();
		writeHentori(hentori);
		FlipBuffer(50);			
		Sleep(910);
	}						
	return res;	
}	

void playBoss(){
	int res = 0;
	write_score = 1; 
	gp_mem_func.free((void*) hentori );
	hentori = NULL;	
	gp_mem_func.free((void*) dragolo );
	dragolo = NULL;		
	hentori = (HENTORI *) gp_mem_func.malloc( sizeof(HENTORI) );
	(*hentori).pos_y=0;
	(*hentori).state=HIDDEN;
	(*hentori).frame=0;		
	(*hentori).frame_move=0;
	(*hentori).speed = Random(5) * 20;
	if ( round%DRAGOLO_FREQ == 0 )
		res = playDragalo();
	else 
		res = playHentori();
	level_score +=  res;		
	if ( res > 0 ) {
		(*hentori).pos_y=1;
		(*hentori).state=MOVE;
		writeScore();
	}
	else {
		writeBackGround();
		writeMonsters();
		if ( round%5 == 0 )
			writeDragolo(dragolo);
		else 	
			writeHentori(hentori);
		FlipBuffer(50);			
		Sleep(2000);	
	}
	write_score = 0; 		
	gp_mem_func.free((void*) hentori );
	hentori = NULL;	
	gp_mem_func.free((void*) dragolo );
	dragolo = NULL;						
}

					

void Play(){
	level_speed = 35;
	pos_min_level_move = 0;
	pos_min_level_move += (2+round-1);
	//pos_min_level_move = 20; // TEST
	pos_min_level_plante = 0;
	pos_min_level_plante += (2+round-1);
	//pos_min_level_plante = 30; // TEST
	
	buildField();
	current_level = MAX_LINE_X-1;
	frame = 1;
	perso_pos_x = MAX_BLOCK_Y / 2 ;
	while (perso_live>0 ){
		playLevel();
		if ( perso_state==ERROR ){
			writeChute();
			perso_live--;
			// perso incrmente score
			writeScore();
			frame = 0;	
		}else {
			perso_vs_boss = -1;
			level_score++;	
			PlayStartBossSound(sound_onoff);
			Sleep(1500);
			write_monsters_score = 1;
			writeScore();
			write_monsters_score = 0;
			playBoss();
			round++;
			perso_pos_x = MAX_BLOCK_Y / 2 ;
			current_level = MAX_LINE_X-1;
			buildField();
			frame = 1;
		}
		clearMonsters();	
	 }
	 PlayEndTune(sound_onoff);	
	 Sleep(2800);
	 
	 if (score > best_score ) {
	 	best_score = score;
	 	if ( (*config).save_score_onoff==SAVE_SCORE_ON )
	 		saveConfig(config, best_score);	
	 }
	KeyGet(&keydata);
	frame =0;
	while ( !( keydata & KEY_START ) ) {
		KeyGet(&keydata);
		if ( frame%40==0 )
			write_score = (write_score == 1 ? -1 : 1 );
		writeBackGround();
		writeClimber();
		FlipBuffer(50);			
	}
	 
	 
}			

void SetPalette(){
	GP_HPALETTE h_pal;
	// Create palette
	h_pal = GpPaletteCreate(256, (GP_PALETTEENTRY*)game_Pal);

	// Change palette
	GpPaletteSelect(h_pal);
	GpPaletteRealize();
		
	// Restore palette
	GpPaletteSelect(h_pal);
				
	// Release resource
	GpPaletteDelete(h_pal);
	h_pal = NULL;		
}

void StartGame(){
	
	SetPalette();
	
	round = 1;
	perso_live = 3;
	score = 0;
	write_score = 0;
	Play();	
}	

void ResetGame(){
	StartGame();
	Start();
}

void ResetData(){
	gp_mem_func.free((void*) level );
	level = NULL;
	clearMonsters();
	gp_mem_func.free((void*) hentori );
	hentori = NULL;	
	gp_mem_func.free((void*) dragolo );
	dragolo = NULL;		
}

void ReturnTitle(){
	ResetData();
	Start();
}

void ResetHardware(){
	ResetData();
	GpMain("reset");	
}

void WriteIntro(){
	WriteIntroScreen(config, best_score, gpDraw, &nflip, &frame);		
}	

void Start(){
	while (1) {
		WriteIntro();	
		StartGame();
	}	
}

void LoadData(){
	gp_mem_func.free((void*) config );
	config = NULL;
	config = (CONFIG *) gp_mem_func.malloc( sizeof(CONFIG) );
		
	loadConfig(config);	
	
	sound_onoff = (*config).sound_onoff;
	best_score = (*config).best_score;	
}

void SetGraphicMode(){
	SetGraphMode( gpDraw, &nflip);
}

void GameMain(){
	GpFatInit();
	SetGraphicMode();
	SetSoundMode();
	LoadData();
	Start();
}			

void GpMain(void *arg)
{	
	if ( arg==NULL )
		GameMain();
}