#ifndef __gpmain_h__
#define __gpmain_h__


#define	LCD_WIDTH	320	//width of LCD
#define	LCD_HEIGHT	240	//height of LCD
#define	BG_WIDTH	320	//width of background image
#define	BG_HEIGHT	240	//height of background image

#define	FIELD_WIDTH	320	
#define	FIELD_HEIGHT	150


#define	STEP_X	10
#define	STEP_Y	10

#define	BLOCK_W 50
#define	BLOCK_H 1

#define	BLOCK_SPACE_W 10
#define	BLOCK_SPACE_H 70

#define	CLIMBER_W 25
#define	CLIMBER_H 26

#define	BLOCKMAN_W 20
#define	BLOCKMAN_H 33

#define	PLANTE_W 5
#define	PLANTE_H 20

#define	EYERON_W 20
#define	EYERON_H 20

#define	HENTORI_W 50
#define	HENTORI_H 25

#define	DRAGOLO_W 50
#define	DRAGOLO_H 30

#define	KNIFE_W 10
#define	KNIFE_H 10


#define	MAX_BLOCK_Y 6
#define	MAX_LINE_X 25

#define	DRAGOLO_FREQ 5

#define	FIX	0
#define	MVT	1
#define	SECRET	2

#define	JUMP	3
#define	FALL	4

#define	HIDDEN	0
#define	MOVE	1

#define	OK	0
#define	ERROR	1
#define SLEEP	2
#define WIN	3

#define MONSTER	0

#define	BLOCKMAN 0
#define	EYERON 1

#define	HLEVEL_FIX 0
#define	HLEVEL_MOVE 1

typedef struct tagHLevel{
	int type;
	int frame;
	int speed;
	int sens;
	int blocks[MAX_BLOCK_Y];
	int plantes[MAX_BLOCK_Y];
	
}HLEVEL;

typedef HLEVEL*  pHLEVEL ;

typedef struct tagLevel{
	int level;
	HLEVEL lines[MAX_LINE_X];
	
}LEVEL;


typedef LEVEL*  pLEVEL ;

typedef struct tagBlock{
	int sens;
	int state;
	int pos_x;
	int pos_y;
	int level;
	int frame;
	int frame_move;
	int speed;
	int type;
}BLOCK;

typedef struct tagHENTORI{
	int pos_y;
	int state;
	int frame;
	int frame_move;
	int speed;
}HENTORI;



typedef struct tagDRAGOLO{
	int pos_y;
	int state;
	int frame;
	int frame_move;
	int speed;
}DRAGOLO;

typedef BLOCK*  pBLOCK ;


void Play(void);
void Start(void);
void WriteIntro(void);
void StartGame(void);
void ResetGame(void);
void ResetHardware(void);
void ReturnTitle(void);
void GpMain(void *arg);

#endif /*__gpmain_h__*/