#include "gpdef.h"
#include "gpstdlib.h"
#include "gpmm.h"

#include "gpstdio.h"

#include "stdio.h"


#include "sound.h"
#include "config.h"


extern const unsigned short boss_lose[14586];
extern const unsigned short chute1[18540];
extern const unsigned short chute2[16950];
extern const unsigned short dragolo_bas[6784];
extern const unsigned short dragolo_haut[5544];
extern const unsigned short dragolo_success[7438];
extern const unsigned short end_tune[31016];
extern const unsigned short hentori_success[9898];
extern const unsigned short hentori_tune[8416];
extern const unsigned short intro_tune[28086];
extern const unsigned short jump1[3116];
extern const unsigned short jump2[2808];
extern const unsigned short jump3[2500];
extern const unsigned short jump4[2776];
extern const unsigned short jump5[2238];
extern const unsigned short jump6[3922]; 
extern const unsigned short move[3574];
extern const unsigned short move_blockman[4800];
extern const unsigned short move_eyeron[8886];
extern const unsigned short snd_score[740];
extern const unsigned short start_boss[15970];
extern const unsigned short touche[8800];


void SetSoundMode(){ 
	GpPcmInit(PCM_M22,PCM_8BIT);
}

void StopPlaySound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmStop(); 
}


void PlayJumpSound(int jumpno, int sound_onoff ){
	if ( sound_onoff == SOUND_OFF )	return;
	if ( jumpno==1 )
		GpPcmPlay((unsigned short*)jump1, sizeof(jump1), 0);
	else if ( jumpno==2 )
		GpPcmPlay((unsigned short*)jump2, sizeof(jump2), 0);
	else if ( jumpno==3 )
		GpPcmPlay((unsigned short*)jump3, sizeof(jump3), 0);
	else if ( jumpno==4 )
		GpPcmPlay((unsigned short*)jump4, sizeof(jump4), 0);
	else if ( jumpno==5 )
		GpPcmPlay((unsigned short*)jump5, sizeof(jump5), 0);
	else if ( jumpno==6 )
		GpPcmPlay((unsigned short*)jump6, sizeof(jump6), 0);
}

void PlayScoreSound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF ) return;
	GpPcmPlay((unsigned short*)snd_score, sizeof(snd_score), 0); 
}

void PlayMoveSound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)move, sizeof(move), 0); 
}

void PlayToucheSound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)touche, sizeof(touche), 0); 
}

void PlayChute1Sound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)chute1, sizeof(chute1), 0); 	
}

void PlayChute2Sound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)chute2, sizeof(chute2), 0); 	
}

void PlayIntroTune(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)intro_tune, sizeof(intro_tune), 0); 
}

void PlayEndTune(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)end_tune, sizeof(end_tune), 0); 
}

void PlayStartBossSound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)start_boss, sizeof(start_boss), 0); 
}

void PlayBossLoseSound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)boss_lose, sizeof(boss_lose), 0); 
}

void PlayBlockmanSound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)move_blockman, sizeof(move_blockman), 0); 
}

void PlayEyeronSound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)move_eyeron, sizeof(move_eyeron), 0); 
}

void PlayHentoriTune(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)hentori_tune, sizeof(hentori_tune), 1); 
}

void PlayHentoriSuccessSound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)hentori_success, sizeof(hentori_success), 0); 
}

void PlayDragoloSound(int dragolo_pos,int sound_onoff ){
	if ( sound_onoff == SOUND_OFF )	return;
	if ( dragolo_pos==0 )
		GpPcmPlay((unsigned short*)dragolo_haut, sizeof(dragolo_haut), 1); 
	else
		GpPcmPlay((unsigned short*)dragolo_bas, sizeof(dragolo_bas), 1); 	
}

void PlayDragoloSuccessSound(int sound_onoff){
	if ( sound_onoff == SOUND_OFF )	return;
	GpPcmPlay((unsigned short*)dragolo_success, sizeof(dragolo_success), 0); 
}

void SoundTest(int pos ){
	StopPlaySound(SOUND_ON);
	if ( pos>=1 && pos<=6 )
		PlayJumpSound(pos,SOUND_ON );
	else if ( pos == 7 )
		PlayMoveSound(SOUND_ON);	
	else if ( pos == 8 )	
		PlayScoreSound(SOUND_ON);
	else if ( pos == 9 )	
		PlayEyeronSound(SOUND_ON);
	else if ( pos == 10 )
		PlayBlockmanSound(SOUND_ON);
	else if ( pos == 11 )	
		PlayIntroTune(SOUND_ON);
	else if ( pos == 12 )	
		PlayToucheSound(SOUND_ON);
	else if ( pos == 13 )	
		PlayChute1Sound(SOUND_ON);
	else if ( pos == 14 )	
		PlayChute2Sound(SOUND_ON);
	else if ( pos == 15 )	
		PlayEndTune(SOUND_ON);
	else if ( pos == 16 )	
		PlayStartBossSound(SOUND_ON);
	else if ( pos == 17 )	
		PlayBossLoseSound(SOUND_ON);
	else if ( pos == 18 )	
		PlayHentoriTune(SOUND_ON);
	else if ( pos == 19 )	
		PlayHentoriSuccessSound(SOUND_ON);
	else if ( pos == 20 )	
		PlayDragoloSound(0,SOUND_ON);
	else if ( pos == 21 )	
		PlayDragoloSound(1,SOUND_ON);
	else if ( pos == 22 )	
		PlayDragoloSuccessSound(SOUND_ON);	
}