#include "gpdef.h"
#include "gpstdlib.h"
#include "gpgraphic.h"
#include "gpmm.h"
#include "gpfont.h"
#include "gpgraphic.h"
#include "gpstdio.h"

#include "draw.h"
#include "config.h"
#include "util.h"

#include "title.h"

extern GP_PALETTEENTRY climber_title_Pal[256];

extern const unsigned char climber_title[];



void WriteIntroScreen(CONFIG * config, int best_score, GPDRAWSURFACE gpDraw [2], int * nflip,  int * frame){

	GP_HPALETTE h_pal;
	char string[256];
	int keydata;
	int position;
	
	GpRectFill(NULL, &gpDraw[*nflip], 0, 0, 320, 240, 0x00);
	FlipSurface(50, gpDraw, nflip, frame);

	// Create palette
	h_pal = GpPaletteCreate(256, (GP_PALETTEENTRY*)climber_title_Pal);

	// Change palette
	GpPaletteSelect(h_pal);
	GpPaletteRealize();
		
	// Restore palette
	GpPaletteSelect(h_pal);
				
	// Release resource
	GpPaletteDelete(h_pal);
	h_pal = NULL;	
	
	
	position = TITLE_POSITION_START;
	
	GpKeyGetEx(&keydata);
	(*frame) = 0;
	while ( !( position == TITLE_POSITION_START &&  ( keydata & KEY_START || keydata & KEY_JUMP ) && GpKeyChanged()) ) {		
		GpKeyGetEx(&keydata);
		
		if ( GpKeyChanged() ){
			if ( keydata & KEY_UP )
				position--;
			else if ( keydata & KEY_DOWN  )	
				position++;
			else if ( position != TITLE_POSITION_START && ( keydata & KEY_START || keydata & KEY_JUMP ) ){
				if ( position == TITLE_POSITION_CONFIG  )
					WriteConfigScreen( config, best_score, gpDraw, nflip, frame );
			}
			
			if ( position	< 0 )
				position = TITLE_NB_POSITIONS_MAX;
			else if ( position > TITLE_NB_POSITIONS_MAX )	
				position = TITLE_POSITION_START;
				
		}	
		
		GpRectFill(NULL, &gpDraw[*nflip], 0, 0, 320, 240, 0x9);
		
		GpTransBlt(NULL, &gpDraw[*nflip],
			           30, 25,
			           260, 70,
			           (unsigned char*)climber_title, 
			           0, 0, 
			           260, 70,
			           0x9);		
		
		gp_str_func.sprintf((char*)string, (best_score<10 ? "Best Score : 000%d": best_score<100 ? "Best Score : 00%d" : best_score<1000 ? "Best Score : 0%d" : "Best Score : %d" ) , best_score );
		GpTextOut(NULL, &gpDraw[*nflip], 90, 115, string, 0x0);
		
		if ( position == TITLE_POSITION_START ){
			if ( ( (*frame)%20>=0 && (*frame)%20<=10 )  )
				GpTextOut(NULL, &gpDraw[*nflip], 115, 150, "START GAME", 0x7c);	
			GpTextOut(NULL, &gpDraw[*nflip], 125, 175, "OPTIONS", 0x0);		
		} else if ( position == TITLE_POSITION_CONFIG ) {
			GpTextOut(NULL, &gpDraw[*nflip], 115, 150, "START GAME", 0x0);	
			if ( ( (*frame)%20>=0 && (*frame)%20<=10 ) )
				GpTextOut(NULL, &gpDraw[*nflip], 125, 175, "OPTIONS", 0x7c);	
		}
		
		GpTextOut(NULL, &gpDraw[*nflip], 180, 215, "Yann Mermet 2004", 0xFC);	
		 
		FlipSurface(50, gpDraw, nflip, frame);	
	}

	GpRectFill(NULL, &gpDraw[*nflip], 0, 0, 320, 240, 0x00);
	FlipSurface(50, gpDraw, nflip, frame);	
}